(* * * * * * * * * * * * * * * * * * *)
(*                                   *)
(*    3- ୮ ࠭⢥  *)
(*   ᪮  .             *)
(*                                   *)
(* * * * * * * * * * * * * * * * * * *)

uses VgaDrv, Crt;

const
  PER = 180;           { 業 ᯥ⨢ }
  maxVertex = 36;      { - 設 }
  maxFace = 23;        { - ࠭ }

type
  vertex = record      { ⨯ 設 }
    x, y, z : real;      { न 設 }
    nx, ny, nz : real;   { ଠ 設 }
  end;
  face = record        { ⨯ ࠭ }
    a, b, c : integer;   { 設 ࠭ }
  end;

var
  V : array[0..maxVertex] of vertex;    { ᨢ 設 }
  RV : array[0..maxVertex] of vertex;   { ᨢ  設 }
  F : array[0..maxFace] of face;        { ᨢ ࠭ }
  fx, fy, fz : real;                    { 㣫   }

{ 楤 樠樨  }
procedure InitObject;
  var
    i : byte;
    ax, ay, az,
    bx, by, bz,
    nx, ny, nz : real;
  begin
    for i := 0 to 11 do
      begin
        {  窨 ᭮ }
        V[i].x := 30*sin(i*pi/6);
        V[i].y := 0;
        V[i].z := 30*cos(i*pi/6);
        {  窨 設 }
        V[i+12].x := 0;
        V[i+12].y := 80;
        V[i+12].z := 0;
        { 㡫㥬 窨 ᭮  ४⭮ ᮢ  }
        V[i+24].x := V[i].x;
        V[i+24].y := V[i].y;
        V[i+24].z := V[i].z;
        { ᢠ ࠭ ⥭ 3 設 }
        F[i].a := i;
        F[i].b := i+12;
        F[i].c := (i+1) mod 12;
        { ᢠ ࠭  3 設 }
        F[i+12].a := 24+((i+1) mod 12);
        F[i+12].b := 24+i;
        F[i+12].c := 36;
      end;
    { । 窠 ᭮  }
    V[36].x := 0; V[36].y := 0; V[36].z := 0;
    { 塞 ଠ ⥭ }
    for i := 0 to 23 do
      begin
        V[i].nx := 0; V[i].ny := 0; V[i].nz := 0;
      end;
    for i := 0 to 11 do
      begin
        { 뢠 ଠ  ᥩ ࠭ }
        ax := V[F[i].c].x-V[F[i].a].x;
        ay := V[F[i].c].y-V[F[i].a].y;
        az := V[F[i].c].z-V[F[i].a].z;
        bx := V[F[i].b].x-V[F[i].a].x;
        by := V[F[i].b].y-V[F[i].a].y;
        bz := V[F[i].b].z-V[F[i].a].z;
        nz := ax*by-ay*bx;
        nx := ay*bz-az*by;
        ny := az*bx-ax*bz;
        { ᢠ  ᥬ 設 ࠭ }
        V[F[i].a].nx := V[F[i].a].nx + nx;
        V[F[i].a].ny := V[F[i].a].ny + ny;
        V[F[i].a].nz := V[F[i].a].nz + nz;
        V[F[i].b].nx := V[F[i].b].nx + nx;
        V[F[i].b].ny := V[F[i].b].ny + ny;
        V[F[i].b].nz := V[F[i].b].nz + nz;
        V[F[i].c].nx := V[F[i].c].nx + nx;
        V[F[i].c].ny := V[F[i].c].ny + ny;
        V[F[i].c].nz := V[F[i].c].nz + nz;
      end;
    { ନ㥬  ଠ ⥭ }
    for i := 0 to 23 do
      begin
        ax := sqrt(V[i].nx*V[i].nx+V[i].ny*V[i].ny+V[i].nz*V[i].nz);
        V[i].nx := V[i].nx/ax;
        V[i].ny := V[i].ny/ax;
        V[i].nz := V[i].nz/ax;
      end;
    {  ଠ ᥬ ࠭  (   ) }
    for i := 24 to 36 do
      begin
        V[i].nx := 0; V[i].ny := -1; V[i].nz := 0;
      end;
  end;

{ 楤   ( 㣫 fx, fy, fz) }
procedure Rotate;
  var
    i : word;
    cy : real;
  begin
    for i := 0 to maxVertex do
      begin
        { 設 }
        RV[i].y := V[i].z*sin(fx)+V[i].y*cos(fx);  { x }
        RV[i].z := V[i].z*cos(fx)-V[i].y*sin(fx);
        RV[i].x := RV[i].z*sin(fy)+V[i].x*cos(fy); { y }
        RV[i].z := RV[i].z*cos(fy)-V[i].x*sin(fy);
        cy := RV[i].y;                             { z }
        RV[i].y := RV[i].x*sin(fz)+cy*cos(fz);
        RV[i].x := RV[i].x*cos(fz)-cy*sin(fz);
        { ଠ }
        RV[i].ny := V[i].nz*sin(fx)+V[i].ny*cos(fx);   { x }
        RV[i].nz := V[i].nz*cos(fx)-V[i].ny*sin(fx);
        RV[i].nx := RV[i].nz*sin(fy)+V[i].nx*cos(fy);  { y }
        RV[i].nz := RV[i].nz*cos(fy)-V[i].nx*sin(fy);
        cy := RV[i].ny;                                { z }
        RV[i].ny := RV[i].nx*sin(fz)+cy*cos(fz);
        RV[i].nx := RV[i].nx*cos(fz)-cy*sin(fz);
      end;
  end;

{  ६ ⠬ }
procedure swapi(var a,b:integer);
  var
    tmp : integer;
  begin
    tmp := a; a := b; b := tmp;
  end;

{ ᮢ ᥣ   }
procedure Render;
  var
    i : byte;
    Ax, Ay, Bx, By, Cx, Cy : integer;
    xs, xe, x, y : integer;
    ca, cb, cc, cs, ce : integer;
    a : real;
  begin
    { ॡࠥ  ࠭ }
    for i := 0 to maxFace do
      begin
        { ᫨ ࠭  殬  , ... }
        if (RV[F[i].c].nz) <= 0 then
          begin
            { 뢠 ᢥ饭  設 A,B,C }
            ca := round(255*abs(RV[F[i].a].nz));
            cb := round(255*abs(RV[F[i].b].nz));
            cc := round(255*abs(RV[F[i].c].nz));

            { ஥㥬 設  ࠭ }
            ax := round(160+RV[F[i].a].x*(PER/(RV[F[i].a].z+PER)));
            ay := round(100-RV[F[i].a].y*(PER/(RV[F[i].a].z+PER)));
            bx := round(160+RV[F[i].b].x*(PER/(RV[F[i].b].z+PER)));
            by := round(100-RV[F[i].b].y*(PER/(RV[F[i].b].z+PER)));
            cx := round(160+RV[F[i].c].x*(PER/(RV[F[i].c].z+PER)));
            cy := round(100-RV[F[i].c].y*(PER/(RV[F[i].c].z+PER)));

            { 㥬 設,  ᮢ 㣮쭨 }
            if (ay>by) then begin swapi(ax,bx); swapi(ay,by); swapi(ca,cb); end;
            if (by>cy) then begin swapi(bx,cx); swapi(by,cy); swapi(cb,cc); end;
            if (ay>by) then begin swapi(ax,bx); swapi(ay,by); swapi(ca,cb); end;

            { 㥬 㣮쭨   ௮樥   設 }
            for y := ay to cy do { ay - .  (y); cy - . . (y) }
              begin
                { 뢠 砫쭮 . x (.)  c (梥) }
                a := (y-ay)/(cy-ay+ord(cy=ay));   { . ௮樨 }
                xs := round(ax+a*(cx-ax));        { 砫쭠 . (x) }
                cs := round(ca+a*(cc-ca));        { 砫쭮 . 梥 }
                if (y < by) then
                  begin
                    { 뢠 筮 祭 x   }
                    a := (y-ay)/(by-ay);          { . ௮樨 }
                    xe := round(ax+a*(bx-ax));    { . . (x) }
                    ce := round(ca+a*(cb-ca));    { . . 梥 }
                  end
                else
                  begin
                    { 뢠 筮 祭 x  c }
                    a := (y-by)/(cy-by+ord(cy=by));   { . ௮樨 }
                    xe := round(bx+a*(cx-bx));        { . . (x) }
                    ce := round(cb+a*(cc-cb));        { . . 梥 }
                  end;
                { 塞 ⠬ start  end, ᫨  }
                if (xs > xe) then begin swapi(xs,xe); swapi(cs,ce); end;
                { 㥬 ਧ⠫   xs  xe
                    室 梥  cs  ce (௮஢)
                    }
                for x := xs to xe do
                  scrbuf^[x,y] := round(cs+(x-xs)*(ce-cs)/(xe-xs+ord(xs=xe)));
              end;
          end;
      end;
  end;

BEGIN
  SetMode($13);                      { ⠭ ० 320x200x256 }
  InitObject;                        { 樠㥬  }
  pal(1,0,30,30);                    { ⠭  }
  palets(2,219,0,0,0,32,32,21);      { -//- }
  palets(220,255,32,32,21,63,63,42); { -//- }
  fx := 0; fy := 0; fz := 0;         {  㣫  0 }
  repeat
    ClrPset(1);                      { 頥  }
    Render;                          { ᮢ뢠    }
    DrawScr;                         { 뢮   ࠭ }
    fx := fx + 0.06;                 { 㢥稢 㣫   }
    fy := fy + 0.04;                 { -//- }
    fz := fz + 0.01;                 { -//- }
    Rotate;                          { 稢 設   㣫 }
  until KeyPressed; ReadKey;
  SetMode(3);                        { ⠭ ⥪⮢ ० }
END.
