Program Lab9;
uses
Crt,Graph;

const
SkinNumber=4;
ViewDist=500;

type
Matrix5=array[0..3, 0..3] of Real;
TVector=array[0..3] of Real;

var
GrDriver,GrMode,ErrorCode:Integer;
Matrix:Matrix5;
VisPage:Byte;

procedure Matrix3D(Angle:Real; var Matrix:Matrix5);
begin
Matrix[0,0]:=Cos(Angle);
Matrix[0,1]:=-Sin(Angle);
Matrix[0,2]:=0;
Matrix[0,3]:=0;
Matrix[1,0]:=Sin(Angle);
Matrix[1,1]:=Cos(Angle);
Matrix[1,2]:=0;
Matrix[1,3]:=0;
Matrix[2,0]:=0;
Matrix[2,1]:=0;
Matrix[2,2]:=1;
Matrix[2,3]:=0;
Matrix[3,0]:=0;
Matrix[3,1]:=0;
Matrix[3,2]:=0;
Matrix[3,3]:=1;
end;

procedure TurnVector(V1:TVector; var V2:TVector; Matrix:Matrix5);
var
I,J:Byte;
begin
for I:=0 to 2 do
    begin
      V2[I]:=0;
      for J:=0 to 2 do
        V2[I]:=V2[I]+Matrix[I, J] * V1[J];
    end;
end;

procedure MovePoint(var X,Y,Z:Real; Matrix:Matrix5);
var
V1,V2:TVector;
begin
V1[0]:=X;
V1[1]:=Y;
V1[2]:=Z;
V1[3]:=1;
TurnVector(V1,V2,Matrix);
X:=V2[0];
Y:=V2[1];
Z:=V2[2];
end;

procedure TurnSkin(var Plane:TVector; Matrix:Matrix5);
var
V:TVector;
begin
TurnVector(Plane,V,Matrix);
Plane:=V;
end;

type
  SkinFigure=record
    Vertexes: array[0..SkinNumber-1] of
    record X,Y,Z:Real;
    end;
    PrVertexes: array[0..SkinNumber-1] of
    record prX,prY:Integer;
    end;
    PlaneCount:Byte;
    Planes:array[0..SkinNumber-1] of record
      Vertexes:String;
      Color:Word;
      Visible:Boolean;
    end;
    PlaneEq:array[0..SkinNumber-1] of TVector;
  end;

var
Figure:SkinFigure;

procedure GetInnerPoint(F:SkinFigure; var V:TVector);
var
I:Integer;
begin
V[0]:=0;
V[1]:=0;
V[2]:=0;
V[3]:=0;
for I:= 0 to SkinNumber-1 do
                          begin
                          V[0]:=V[0]+F.Vertexes[I].X;
                          V[1]:=V[1]+F.Vertexes[I].Y;
                          V[2]:=V[2]+F.Vertexes[I].Z;
                          end;
V[0]:=V[0]/SkinNumber;
V[1]:=V[1]/SkinNumber;
V[2]:=V[2]/skinNumber;
end;

function GetVertexIndex(S:String; N:Byte):Byte;
begin
GetVertexIndex:=Byte(S[N+1]);
end;

function MulVectors(V1,V2:TVector):Real;
var
I:Integer;
Result:Real;
begin
Result:= 0;
for I:= 0 to High(V1) do
Result:= Result+V1[I] * V2[I];
MulVectors:= Result;
end;

procedure EvalPlanesEq(var F:SkinFigure);
var
I:Integer;
x1,x2,x3,y1,y2,y3,z1,z2,z3:Real;
ax,ay,az,bx,by,bz:Real;
V:TVector;
begin
GetInnerPoint(F,V);
with F do
    for I:=0 to PlaneCount-1 do
      begin
        with Vertexes[GetVertexIndex(Planes[I].Vertexes,0)] do
          begin
            x1:=X;
            y1:=Y;
            z1:=Z;
          end;
        with Vertexes[GetVertexIndex(Planes[I].Vertexes,1)] do
          begin
            x2:=X;
            y2:=Y;
            z2:=Z;
          end;
        with Vertexes[GetVertexIndex(Planes[I].Vertexes,2)] do
          begin
            x3:=X;
            y3:=Y;
            z3:=Z;
          end;
        ax:=x2-x1;
        ay:=y2-y1;
        az:=z2-z1;
        bx:=x3-x1;
        by:=y3-y1;
        bz:=z3-z1;
        PlaneEq[I,0]:=ay*bz-by*az;
        PlaneEq[I,1]:=bx*az-ax*bz;
        PlaneEq[I,2]:=ax*by-bx*ay;
        PlaneEq[I,3]:=-PlaneEq[I,0] * x1 -
                          PlaneEq[I,1]*y1 -
                          PlaneEq[I,2]*z1;
        if MulVectors(V, PlaneEq[I]) > -PlaneEq[I, 3] then
          begin
            PlaneEq[I,0]:=-PlaneEq[I,0];
            PlaneEq[I,1]:=-PlaneEq[I,1];
            PlaneEq[I,2]:=-PlaneEq[I,2];
            PlaneEq[I,3]:=-PlaneEq[I,3];
          end;
      end;
end;

function SkinLocationVis(F:SkinFigure; N:Byte):Boolean;
var
V1,V2:TVector;
begin
with F.Vertexes[GetVertexIndex(F.Planes[N].Vertexes,0)] do
    begin
    V1[0]:=X-ViewDist;
    V1[1]:=Y;
    V1[2]:=Z;
    V1[3]:=0;
    end;
V2:=F.PlaneEq[N];
SkinLocationVis:=MulVectors(V1, V2)<0;
end;

procedure TurnFigure(var F:SkinFigure; Matrix:Matrix5);
var
I:Integer;
begin
for I := 0 to SkinNumber-1 do
    with F.Vertexes[I] do
      MovePoint(X, Y, Z, Matrix);
for I := 0 to F.PlaneCount - 1 do
    with F do TurnSkin(PlaneEq[I], Matrix);
end;

procedure Projection(X,Y,Z:Real; var prX,prY:Integer);
var
P:Real;
begin
P:= ViewDist /(ViewDist-X);
prX:=320+Round(Y*P);
prY:=175-Round(Z*P);
end;

procedure ProjectFigure(var F:SkinFigure);
var
I:Integer;
begin
  for I:=0 to SkinNumber-1 do
    with F.Vertexes[I], F.PrVertexes[I] do
      Projection(X,Y,Z,prX,prY);
  for I:=0 to F.PlaneCount-1 do
    F.Planes[I].Visible:=SkinLocationVis(F, I);
end;

procedure DrawProjected(F:SkinFigure);
var
I,J:Integer;
FlX,FlY:Integer;
begin
  with F do
    for I:=0 to PlaneCount-1 do
      if Planes[I].Visible then
        begin
          FlX:=0;
          FlY:=0;
          with PrVertexes[GetVertexIndex(Planes[I].Vertexes,0)] do
            MoveTo(PrX, PrY);
          for J:=1 to Length(Planes[I].Vertexes)-1 do
            with PrVertexes[GetVertexIndex(Planes[I].Vertexes,J)] do
              begin
                LineTo(PrX, PrY);
                FlX:=FlX+PrX;
                FlY:=FlY+PrY;
              end;
          with PrVertexes[GetVertexIndex(Planes[I].Vertexes,0)] do
            begin
              LineTo(PrX, PrY);
              FlX:=FlX+PrX;
              FlY:=FlY+PrY;
            end;
          FlX:=Round(FlX /Length(Planes[I].Vertexes));
          FlY:=Round(FlY /Length(Planes[I].Vertexes));
          SetFillStyle(SolidFill, Planes[I].Color);
          if GetPixel(FlX,FlY)<>White then FloodFill(FlX,FlY,White);
        end;
end;

procedure BlinkPages;
begin
SetActivePage(VisPage);
VisPage:=1-VisPage;
SetVisualPage(VisPage);
end;

procedure DrawFigure(F:SkinFigure);
begin
ProjectFigure(F);
DrawProjected(F);
BlinkPages;
end;

procedure InitiateFigure;
begin
with Figure do
            begin
            Vertexes[0].X:=0;
            Vertexes[0].Y:=120;
            Vertexes[0].Z:=130;
            Vertexes[1].X:=100;
            Vertexes[1].Y:=180;
            Vertexes[1].Z:=60;
            Vertexes[2].X:=-100;
            Vertexes[2].Y:=180;
            Vertexes[2].Z:=60;
            Vertexes[3].X:=-60;
            Vertexes[3].Y:=60;
            Vertexes[3].Z:=60;
            PlaneCount:=4;
            Planes[0].Vertexes:=#0#1#2;
            Planes[0].Color:=Brown;
            Planes[1].Vertexes:=#0#2#3;
            Planes[1].Color:=LightRed;
            Planes[2].Vertexes:=#0#3#1;
            Planes[2].Color:=Magenta;
            Planes[3].Vertexes:=#1#2#3;
            Planes[3].Color:=Blue;
            end;
EvalPlanesEq(Figure);
end;


BEGIN
InitiateFigure;
Matrix3D(Pi/120,Matrix);
DetectGraph(GrDriver,GrMode);
GrMode:=VGAMed;
InitGraph(GrDriver,GrMode,'e:\bpascal7\bgi');
ErrorCode:=GraphResult;
if Errorcode<>GrOk then
                   begin
                   Writeln('訡 樠樨 䨪:',
                   GraphErrorMsg(ErrorCode));
                   Halt(1);
                   end;
SetColor(White);
SetActivePage(1);
Outtext(' ENTER');
DrawFigure(Figure);
VisPage:=0;
ReadLn;
repeat
ClearDevice;
Setcolor(11);
Outtext(' ENTER');
TurnFigure(Figure,Matrix);
SetColor(White);
DrawFigure(Figure);
Delay(800);
until KeyPressed;
CloseGraph;
END.
